package com.hotwj.platform.securityManagement.trainingOutlineMonth.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.securityManagement.trainingOutlineMonth.domain.HotTrainingOutlineMonth;
import com.hotwj.platform.securityManagement.trainingOutlineMonth.domain.bo.HotTrainingOutlineMonthBo;
import com.hotwj.platform.securityManagement.trainingOutlineMonth.domain.vo.HotTrainingOutlineMonthVo;
import com.hotwj.platform.securityManagement.trainingOutlineMonth.mapper.HotTrainingOutlineMonthMapper;
import com.hotwj.platform.securityManagement.trainingOutlineMonth.service.IHotTrainingOutlineMonthService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 培训大纲-月度计划Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-14
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotTrainingOutlineMonthServiceImpl implements IHotTrainingOutlineMonthService {

    private final HotTrainingOutlineMonthMapper baseMapper;

    /**
     * 查询培训大纲-月度计划
     *
     * @param id 主键
     * @return 培训大纲-月度计划
     */
    @Override
    public HotTrainingOutlineMonthVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询培训大纲-月度计划列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 培训大纲-月度计划分页列表
     */
    @Override
    public TableDataInfo<HotTrainingOutlineMonthVo> queryPageList(HotTrainingOutlineMonthBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotTrainingOutlineMonth> lqw = buildQueryWrapper(bo);
        Page<HotTrainingOutlineMonthVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的培训大纲-月度计划列表
     *
     * @param bo 查询条件
     * @return 培训大纲-月度计划列表
     */
    @Override
    public List<HotTrainingOutlineMonthVo> queryList(HotTrainingOutlineMonthBo bo) {
        LambdaQueryWrapper<HotTrainingOutlineMonth> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotTrainingOutlineMonth> buildQueryWrapper(HotTrainingOutlineMonthBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotTrainingOutlineMonth> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotTrainingOutlineMonth::getId);
        lqw.eq(bo.getOutlineId() != null, HotTrainingOutlineMonth::getOutlineId, bo.getOutlineId());
        lqw.eq(bo.getSortNo() != null, HotTrainingOutlineMonth::getSortNo, bo.getSortNo());
        lqw.eq(StringUtils.isNotBlank(bo.getPlanMonth()), HotTrainingOutlineMonth::getPlanMonth, bo.getPlanMonth());
        lqw.eq(StringUtils.isNotBlank(bo.getTopic()), HotTrainingOutlineMonth::getTopic, bo.getTopic());
        lqw.eq(StringUtils.isNotBlank(bo.getOutlineIds()), HotTrainingOutlineMonth::getOutlineIds, bo.getOutlineIds());
        lqw.eq(bo.getIsDeleted() != null, HotTrainingOutlineMonth::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增培训大纲-月度计划
     *
     * @param bo 培训大纲-月度计划
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotTrainingOutlineMonthBo bo) {
        HotTrainingOutlineMonth add = MapstructUtils.convert(bo, HotTrainingOutlineMonth.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改培训大纲-月度计划
     *
     * @param bo 培训大纲-月度计划
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotTrainingOutlineMonthBo bo) {
        HotTrainingOutlineMonth update = MapstructUtils.convert(bo, HotTrainingOutlineMonth.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotTrainingOutlineMonth entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除培训大纲-月度计划信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
